## cppad 2023.00.00.0

=== CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-23 Bradley M. Bell
# ----------------------------------------------------------------------------
# =============================================================================
# Some constants
# =============================================================================
#
# Set the minimum required version of cmake for this project.
# see http://www.cmake.org/pipermail/cmake/2013-January/053213.html
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
#
# Only interpret if() arguments as variables or keywords when unquoted.
IF( POLICY CMP0054 )
  CMAKE_POLICY(SET CMP0054 NEW)
ENDIF( POLICY CMP0054 )
#
# cppad_version is used by version.sh to get the version number.
SET(cppad_version "20230000.0")
SET(cppad_url          "https://coin-or.github.io/CppAD" )
SET(cppad_description  "Differentiation of C++ Algorithms" )
#
# Set name of this project and create the variables
# cppad_BINARY_DIR and cppad_SOURCE_DIR.
# project(projectname [CXX] [C] [Java])
PROJECT(cppad)
#
# Add the include sub-directory to the list of C++ preprocessor
# include directories for the entire project.  The SYSTEM flag is not included
# so warnings will be geenreated for this directory.
INCLUDE_DIRECTORIES( ${cppad_SOURCE_DIR}/include )
#
# =============================================================================
# Some system cmake language extensions
# =============================================================================
# CHECK_CXX_SOURCE_COMPILES(source variable)
# Checks whether the code given in source will compile, link and run and
# return zero status. You can set
# CMAKE_REQUIRED_LIBRARIES, CMAKE_REQUIRED_FLAGS and CMAKE_REQUIRED_INCLUDES
# accordingly if additional libraries or compiler flags are required.
INCLUDE(CheckCXXSourceCompiles)
# ============================================================================
# Some local cmake language
# ============================================================================
# assert_value_in_set(value element_1 ... element_n)
INCLUDE(cmake/assert_value_in_set.cmake)
#
# dos_path_to_unix(dos_path unix_path)
INCLUDE(cmake/dos_path_to_unix.cmake)
#
# add_to_list(variable_list constant_value)
INCLUDE(cmake/add_to_list.cmake)
#
# command_line_arg(variable default type description)
INCLUDE(cmake/command_line_arg.cmake)
#
# prefix_info(package description)
INCLUDE(cmake/prefix_info.cmake)
#
# compile_source_test(source variable)
INCLUDE(cmake/compile_source_test.cmake)
#
# assert(variable)
INCLUDE(cmake/assert.cmake)
#
# print_variable(variable)
INCLUDE(cmake/print_variable.cmake)
#
# set_compile_flags( program_name debug_which source_list)
INCLUDE(cmake/set_compile_flags.cmake)
#
# pkgconfig_info(name, system)
INCLUDE(cmake/pkgconfig_info.cmake)
#
# add_check_executable(parent_target short_name)
INCLUDE(cmake/add_check_executable.cmake)
# =============================================================================
# command line arguments
# =============================================================================
# Arguments that are no longer used
#
IF( debug_which )
   MESSAGE(FATAL_ERROR
      "Using debug_which, use cppad_debug_which or CMAKE_BUILD_TYPE instead"
   )
ENDIF( debug_which )
#
IF( cppad_sparse_list )
   MESSAGE(FATAL_ERROR
      "cppad_sparse_list has been removed from cmake command"
   )
ENDIF( cppad_sparse_list )
#
IF( cppad_deprecated )
   MESSAGE(FATAL_ERROR "cppad_deprecated has been removed from cmake comamnd" )
ENDIF( cppad_deprecated )
#
IF( cmake_install_prefix )
   MESSAGE(FATAL_ERROR
      "cmake_install_prefix has been changed to cppad_prefix"
   )
ENDIF( cmake_install_prefix )
#
IF( cmake_install_postfix )
   MESSAGE(FATAL_ERROR
      "cmake_install_postfix has been changed to cppad_postfix"
   )
ENDIF( cmake_install_postfix )
#
FOREACH(pkg adolc ipopt cppadcg)
   IF( ${pkg}_prefix )
      MESSAGE(FATAL_ERROR
         "-D ${pkg}_prefix=value has been changed to -D include_${pkg}=true"
      )
   ENDIF( ${pkg}_prefix )
ENDFOREACH(pkg adolc eigen ipopt)
# -----------------------------------------------------------------------------
# Current Arguments
#
# cmake_needs_dot_slash
command_line_arg(cmake_needs_dot_slash "false" BOOL
"does cmake need a ./ in the front of an executable name in a custom command"
)
#
# cmake_install_datadir
command_line_arg(cmake_install_datadir share STRING
   "directory, below prefix, where cmake installs cppad data files"
)
#
# cmake_install_docdir
command_line_arg(cmake_install_docdir NOTFOUND STRING
   "directory, below prefix, where cmake installs cppad documentation files"
)
#
# cmake_install_includedirs
command_line_arg(cmake_install_includedirs include STRING
   "directories, below prefix, where cmake installs include files"
)
#
# cmake_install_libdirs
command_line_arg(cmake_install_libdirs lib STRING
   "directories, below prefix, where cmake installs library files"
)
#
# cmake_defined_ok
command_line_arg(cmake_defined_ok TRUE BOOL
   "If false, check that some symbols only get defined once"
   "If true, you can use CMakeCache.txt to store previous settings"
)
#
# cppad_prefix
command_line_arg(cppad_prefix "${CMAKE_INSTALL_PREFIX}" PATH
   "cppad install prefix"
)
#
# cppad_postfix
command_line_arg(cppad_postfix NOTFOUND STRING
   "cppad install postfix"
)
#
# cppad_cxx_flags
command_line_arg(cppad_cxx_flags "" STRING
   "compile flags used with cppad (besides debug, release, and profile flags)"
)
#
# cppad_profile_flag
command_line_arg(cppad_profile_flag NOTFOUND STRING
   "compile flag used to compile and link a profile version of a program"
)
#
# cppad_testvector
command_line_arg(cppad_testvector cppad STRING
   "Namespace of vector used for testing, one of: boost, cppad, eigen, std"
)
assert_value_in_set(cppad_testvector boost cppad eigen std)
#
# cppad_max_num_threads
command_line_arg(cppad_max_num_threads 48 STRING
   "maximum number of threads that CppAD can use use"
)
IF( "${cppad_max_num_threads}" LESS "4" )
   MESSAGE(FATAL_ERROR
      "cppad_max_num_threads is not an integer greater than or equal 4"
   )
ENDIF( "${cppad_max_num_threads}" LESS "4" )
#
# cppad_tape_id_type
command_line_arg(cppad_tape_id_type "unsigned int" STRING
   "type used to identify different tapes, size must be <= sizeof(size_t)"
)
#
# cppad_tape_addr_type
command_line_arg(cppad_tape_addr_type "unsigned int" STRING
"type used to identify variables on one tape, size must be <= sizeof(size_t)"
)
# ----------------------------------------------------------------------------
#
# Ensure c++11 support
SET(CMAKE_REQUIRED_DEFINITIONS "")
SET(CMAKE_REQUIRED_FLAGS       "${cppad_cxx_flags}")
SET(CMAKE_REQUIRED_INCLUDES    "")
SET(CMAKE_REQUIRED_LIBRARIES   "")
SET(source "
int main(void)
{  static_assert( __cplusplus >= 201103 , \"c++11 is supported\" );
   return 0;
}"
)
compile_source_test(${cmake_defined_ok} "${source}" minimal_cplusplus )
IF( NOT minimal_cplusplus  )
   MESSAGE(STATUS "setting C++ standard to 2011")
   SET(CMAKE_CXX_STANDARD 11)
   SET(CMAKE_CXX_STANDARD_REQUIRED ON)
ENDIF( NOT minimal_cplusplus  )
#
# use_cplusplus_2017_ok
SET(source "
int main(void)
{  static_assert( __cplusplus >= 201703 , \"c++17 is supported\" );
   return 0;
}"
)
compile_source_test(${cmake_defined_ok} "${source}" use_cplusplus_2017_ok )
# ----------------------------------------------------------------------------
#
# cppad_debug_which
# CMAKE_BUILD_TYPE
SET(debug_even_or_odd FALSE)
IF( NOT ${cppad_debug_which} STREQUAL "" )
   assert_value_in_set(
      cppad_debug_which debug_even debug_odd debug_all debug_none
   )
ENDIF( NOT ${cppad_debug_which} STREQUAL "" )
IF( CMAKE_BUILD_TYPE )
   IF( NOT ${cppad_debug_which} STREQUAL "" )
      print_variable(CMAKE_BUILD_TYPE)
      print_variable(cppad_debug_which)
      MESSAGE(FATAL_ERROR
         "Both CMAKE_BUILD_TYPE and cppad_debug_which specified"
      )
   ENDIF( NOT ${cppad_debug_which} STREQUAL "" )
   IF(CMAKE_BUILD_TYPE MATCHES Debug)
      SET(cppad_debug_which "debug_all")
   ELSEIF(CMAKE_BUILD_TYPE MATCHES Release)
      SET(cppad_debug_which "debug_none")
   ELSEIF(CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
      SET(cppad_debug_which "debug_none")
   ELSEIF(CMAKE_BUILD_TYPE MATCHES MinSizeRel)
      SET(cppad_debug_which "debug_none")
   ENDIF()
ELSE( CMAKE_BUILD_TYPE )
   IF( "${cppad_debug_which}" STREQUAL debug_all)
      SET(CMAKE_BUILD_TYPE Debug)
   ELSEIF( "${cppad_debug_which}" STREQUAL debug_none)
      SET(CMAKE_BUILD_TYPE Release)
   ELSEIF( "${cppad_debug_which}" STREQUAL debug_odd)
      SET(CMAKE_BUILD_TYPE Debug)
      SET(debug_even_or_odd TRUE)
   ELSEIF( "${cppad_debug_which}" STREQUAL debug_even)
      SET(CMAKE_BUILD_TYPE Release)
      SET(debug_even_or_odd TRUE)
   ENDIF( "${cppad_debug_which}" STREQUAL debug_all)
ENDIF( CMAKE_BUILD_TYPE )
IF( ${CMAKE_SYSTEM_NAME} STREQUAL "Windows" )
   IF( debug_even_or_odd )
      MESSAGE(FATAL_ERROR
      "Cannot have cppad_debug_which equal ${cppad_debug_which} on Windows."
      )
   ENDIF( debug_even_or_odd )
ENDIF( ${CMAKE_SYSTEM_NAME} STREQUAL "Windows" )
print_variable(CMAKE_SYSTEM_NAME)
print_variable(cppad_debug_which)
print_variable(CMAKE_BUILD_TYPE)
MESSAGE(STATUS "make check: avialable")
# -----------------------------------------------------------------------------
# CMAKE_INSTALL_PREFIX
SET(CMAKE_INSTALL_PREFIX "${cppad_prefix}"
   CACHE PATH "value copied from cppad_prefix" FORCE
)
# -----------------------------------------------------------------------------
# Optional package information
SET(system_include TRUE)
#
# eigen
IF( ${include_eigen} )
   pkgconfig_info(eigen ${system_include})
   IF( DEFINED eigen_prefix )
      MESSAGE(FATAL_ERROR "include_eigen is true and eigen_prefix is defined")
   ENDIF( )
ELSE( )
   prefix_info(eigen ${system_include} )
ENDIF( )
#
# adolc
pkgconfig_info(adolc ${system_include})
#
# ipopt
pkgconfig_info(ipopt ${system_include})
#
# colpack_prefix
prefix_info(colpack ${system_include} )
#
# sacado_prefix
prefix_info(sacado ${system_include} )
#
# fadbad_prefix
prefix_info(fadbad ${system_include} )
#
# include_cpapdcg
SET( include_cppadcg FALSE CACHE BOOL "include cppadcg" )
IF( include_cppadcg )
   #
   # cppad_has_cppadcg
   SET(cppad_has_cppadcg 1)
   #
   # Assume bin/get_cppadcg.sh puts include files in this directory
   SET(cppadcg_include_dir "${CMAKE_BINARY_DIR}/prefix/include" )
   print_variable(cppadcg_include_dir)
   INCLUDE_DIRECTORIES( SYSTEM ${cppadcg_include_dir})
ELSE( )
   # cppad_has_cppadcg
   SET(cppad_has_cppadcg 0)
ENDIF( include_cppadcg )
# =============================================================================
# cppad_lib
# Perhaps in the future cppad_lib will depend on cmake header only flag ?
SET( cppad_lib    "cppad_lib" )
LINK_DIRECTORIES( ${cppad_BINARY_DIR}/cppad_lib )
# =============================================================================
# colpack_libs
#
IF( cppad_has_colpack )
   SET( colpack_libs "ColPack" )
ELSE( cppad_has_colpack )
   SET( colpack_libs "" )
ENDIF( cppad_has_colpack )
# =============================================================================
# automated system configuration
# =============================================================================
# CMAKE_CXX_FLAGS
IF( "${cppad_debug_which}" STREQUAL "debug_all" )
   print_variable(CMAKE_CXX_FLAGS_DEBUG)
ELSEIF( "${cppad_debug_which}" STREQUAL "debug_none" )
   print_variable(CMAKE_CXX_FLAGS_RELEASE)
ELSE( "${cppad_debug_which}" )
   print_variable(CMAKE_CXX_FLAGS_DEBUG)
   print_variable(CMAKE_CXX_FLAGS_RELEASE)
ENDIF( "${cppad_debug_which}" STREQUAL "debug_all" )
# -----------------------------------------------------------------------------
# cppad_abs_includedir, cppad_abs_libdir, cppad_abs_datadir, cppad_abs_docdir
#
# for dir_types = includedirs, libdirs, datadir, docdir
FOREACH(dir_types includedirs libdirs datadir docdir)
   # set dir_type = dir_types with  "dirs" -> "dir"

=== example/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example directory tests
# Inherit environment from ../CMakeList.txt

# initialize check_example_depends
SET(check_example_depends "")
#
# BEGIN_SORT_THIS_LINE_PLUS_1
ADD_SUBDIRECTORY(abs_normal)
ADD_SUBDIRECTORY(atomic_four)
ADD_SUBDIRECTORY(atomic_three)
ADD_SUBDIRECTORY(atomic_two)
ADD_SUBDIRECTORY(chkpoint_two)
ADD_SUBDIRECTORY(general)
ADD_SUBDIRECTORY(get_started)
ADD_SUBDIRECTORY(graph)
ADD_SUBDIRECTORY(jit)
ADD_SUBDIRECTORY(json)
ADD_SUBDIRECTORY(multi_thread)
ADD_SUBDIRECTORY(optimize)
ADD_SUBDIRECTORY(print_for)
ADD_SUBDIRECTORY(sparse)
ADD_SUBDIRECTORY(utility)
# END_SORT_THIS_LINE_MINUS_1
#
# code_gen_fun examples
IF( cppad_has_cppadcg )
   ADD_SUBDIRECTORY(code_gen_fun)
ENDIF( cppad_has_cppadcg )
#
# ipopt_solve examples
IF( cppad_has_ipopt)
   ADD_SUBDIRECTORY(ipopt_solve)
ENDIF( cppad_has_ipopt)


# Add the check_example target
ADD_CUSTOM_TARGET(check_example "" DEPENDS ${check_example_depends})
MESSAGE(STATUS "make check_example: available")

# Change check depends in parent environment
add_to_list(check_depends check_example)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== pkgconfig/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Construct cppad.pc from cppad.pc.in; see
# http://people.freedesktop.org/~dbn/pkg-config-guide.html
# -----------------------------------------------------------------------------
# {xrst_begin pkgconfig} 
# {xrst_spell
#     builddir
#     cflags
#     datadir
#     gnu
#     includedir
#     libdir
#     libs
#     pkgconfig
#     uninstalled
# }
# {xrst_comment_ch #}
#
# CppAD pkg-config Files
# ######################
#
# Purpose
# *******
# The ``pkg-config`` program helps with the used if installed libraries
# and include files; see its
# `guide <https://people.freedesktop.org/~dbn/pkg-config-guide.html>`_
# for more information on writing an using pkg-config files.
#
# cppad.pc
# ********
#
# PKG_CONFIG_PATH
# ===============
# The ``cppad.pc`` file is installed in the following two directories:
#
# | |tab| *prefix* / *libdir* / ``pkgconfig``
# | |tab| *prefix* / *datadir* / ``pkgconfig``
#
# where *prefix* is :ref:`cmake@cppad_prefix` ,
# *libdir* is the first entry in
# :ref:`cmake@cmake_install_libdirs` ,
# and # *datadir* is
# :ref:`cmake@cmake_install_datadir` .
# In order to use ``pkg-config`` ,
# one of these directories must your ``PKG_CONFIG_PATH`` .
#
# Compile Flags
# =============
# The necessary flags for compiling code that includes CppAD can
# be obtained with the command
# ::
#
#     pkg-config --cflags cppad
#
# Link Flags
# ==========
# The flags for linking can be obtains with the command
# ::
#
#     pkg-config --libs cppad
#
# Extra Definitions
# =================
# The ``cppad.pc`` file contains the text:
#
# | |tab| ``prefix`` = *prefix*
# | |tab| ``exec_prefix`` = *exec_prefix*
# | |tab| ``includedir`` = *includedir*
# | |tab| ``libdir`` = *libdir*
#
# where *prefix* , *exec_prefix* , *includedir* , and
# *libdir* are the
# `gnu installation variables <https://www.gnu.org/prep/standards/html_node/Directory-Variables.html>`_.
#
# cppad-uninstalled.pc
# ********************
#
# PKG_CONFIG_PATH
# ===============
# The ``cppad-uninstalled.pc`` file is located in the following directory:
#
#     *builddir* / ``pkgconfig``
#
# where *builddir* is the directory where the :ref:`cmake-name` command
# is executed.
#
# Compile Flags
# =============
# The necessary flags for compiling code that includes CppAD,
# before CppAD is installed, can be obtained with the command
# ::
#
#     pkg-config --cflags cppad-uninstalled
#
# Link Flags
# ==========
# The flags for linking can be obtains with the command
# ::
#
#     pkg-config --libs cppad-uninstalled
#
# Extra Definitions
# =================
# The ``cppad-uninstalled.pc`` file has the same extra variables
# as the ``cppad.pc`` file.
#
# {xrst_end pkgconfig}
# ----------------------------------------------------------------------------
#
# The following variables are used by cppad.pc.in
# and set in the top source CMakeLists.txt:
#  cppad_prefix,
#  cppad_description,
#  cppad_version,
#  cppad_url,
#  cppad_lib
# The other variables used by cppad.pc.in are set below
# Note that cppad_SOURCE_DIR is used by cppad-uninstalled.pc
# and is set by cmake to the top soruce directory.
#
# cppad_includedir
LIST(GET cmake_install_includedirs 0 cppad_includedir)
#
# cppad_libdir
LIST(GET cmake_install_libdirs 0 cppad_libdir)
#
# add_to_set
MACRO(add_to_set variable_name element)
   IF( "${${variable_name}}" STREQUAL "" )
      SET(${variable_name} ${element} )
   ELSE( "${${variable_name}}" STREQUAL "" )
      LIST(FIND ${variable_name} ${element} index)
      IF( index EQUAL -1 )
         SET(${variable_name} "${${variable_name}} ${element}")
      ENDIF( index EQUAL -1 )
   ENDIF( "${${variable_name}}" STREQUAL "" )
ENDMACRO(add_to_set variable_name element)
# -----------------------------------------------------------------------------
# initialize
SET(cppad_libdir_list "-L${cppad_prefix}/${cppad_libdir}")
SET(cppad_lib_list    "-l${cppad_lib}")
SET(cppad_requires         "")
SET(cppad_libs_private     "")
SET(cppad_requires_private "")
#
# Colpack does not have a pkgconfig file.
SET(colpack_libdir     NOTFOUND)
IF( cppad_has_colpack )
   FOREACH(dir ${cmake_install_libdirs})
      FILE(GLOB file_list "${colpack_prefix}/${dir}/libColPack.*" )
      IF( file_list )
         SET(colpack_libdir "${colpack_prefix}/${dir}")
      ENDIF( file_list )
   ENDFOREACH(dir ${cmake_install_libdirs})
   IF( NOT colpack_libdir )
      MESSAGE(FATAL_ERROR "Cannit find libColPack.* below ${colpack_prefix}")
   ENDIF( NOT colpack_libdir )
   add_to_set(cppad_libdir_list "-L${colpack_libdir}")
   add_to_set(cppad_lib_list    "-lColPack")
ENDIF( cppad_has_colpack )
#
# Ipopt has a pkgconfig file.
IF( cppad_has_ipopt )
   SET(cppad_requires         "${cppad_requires} ipopt")
   add_to_set(cppad_lib_list  "-lcppad_ipopt" )
ENDIF( cppad_has_ipopt )
# -----------------------------------------------------------------------------
# cppad.pc
CONFIGURE_FILE(
   ${CMAKE_CURRENT_SOURCE_DIR}/cppad.pc.in
   ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
   @ONLY
)
# cppad-uninstalled.pc
CONFIGURE_FILE(
   ${CMAKE_CURRENT_SOURCE_DIR}/cppad-uninstalled.pc.in
   ${CMAKE_CURRENT_BINARY_DIR}/cppad-uninstalled.pc
   @ONLY
)
# During install copy cppad.pc to datadir
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
   DESTINATION ${cppad_abs_datadir}/pkgconfig
)
# During install also copy cppad.pc to libdir
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
   DESTINATION ${cppad_abs_libdir}/pkgconfig
)

=== test_more/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the test_more directory tests

# initialize check_depends
SET(check_test_more_depends "")

# deprecated tests
ADD_SUBDIRECTORY(deprecated)

# compare_c tests
ADD_SUBDIRECTORY(compare_c)

# debug_rel tests
IF( NOT "${CMAKE_GENERATOR}" STREQUAL "NMake Makefiles" )
   # Visual studio rejects mixing debug and release flags
   ADD_SUBDIRECTORY(debug_rel)
ENDIF( NOT "${CMAKE_GENERATOR}" STREQUAL "NMake Makefiles" )
#
# cppad_for_tmb tests
IF( OpenMP_CXX_FOUND )
   ADD_SUBDIRECTORY(cppad_for_tmb)
ENDIF( OpenMP_CXX_FOUND )

# general tests
ADD_SUBDIRECTORY(general)

# Add the check_example target
ADD_CUSTOM_TARGET(check_test_more "" DEPENDS ${check_test_more_depends})
MESSAGE(STATUS "make check_test_more: available")

# Change check depends in parent environment
add_to_list(check_depends check_test_more)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== cppad_ipopt/example/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Inherit build type from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
LINK_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR}/../src ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   example.cpp
   get_started.cpp
   ode_check.cpp
   ode_check.hpp
   ode_fast.hpp
   ode_fast_check.cpp
   ode_problem.hpp
   ode_run.hpp
   ode_simple.hpp
   ode_simple_check.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags( cppad_ipopt_example "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( cppad_ipopt_example EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(cppad_ipopt_example
   cppad_ipopt
   ${cppad_lib}
   ${ipopt_LIBRARIES}
   ${colpack_libs}
)

#
# check_cppad_ipopt_example
add_check_executable(check_cppad_ipopt example)

=== cppad_ipopt/speed/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the cppad_ipopt/speed directory tests
# Inherit build type from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
# (cannot use ../src/cppad_ipopt library because it is linke with debugging)
LINK_DIRECTORIES( ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
# Include source for cppad_ipopt library so we build it without debugging
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   ../src/cppad_ipopt_nlp.cpp
   ../src/fun_record.hpp
   ../src/hes_fg_map.cpp
   ../src/jac_g_map.cpp
   ../src/sparse_map2vec.cpp
   ../src/vec_fun_pattern.cpp
   ode_speed.cpp
   speed.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags( cppad_ipopt_example "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( cppad_ipopt_speed EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(
   cppad_ipopt_speed
   cppad_ipopt
   ${cppad_lib}
   ${ipopt_LIBRARIES}
   ${colpack_libs}
)

# check_cppad_ipopt_speed
add_check_executable(check_cppad_ipopt speed)

=== cppad_ipopt/test/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the cppad_ipopt/test directory tests
# Inherit build tyope from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
LINK_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR}/../src ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list test_more.cpp
   k_gt_one.cpp
   multiple_solution.cpp
   retape_k1_l1.cpp
   retape_k1_l2.cpp
)
set_compile_flags( cppad_ipopt_test "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( cppad_ipopt_test EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(cppad_ipopt_test
   cppad_ipopt
   ${cppad_lib}
   ${ipopt_LIBRARIES}
   ${colpack_libs}
)

# check_cppad_ipopt_test
add_check_executable(check_cppad_ipopt test)

=== example/general/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example/general directory tests
#
# adolc_sources
IF( cppad_has_adolc )
   SET(adolc_sources mul_level_adolc.cpp mul_level_adolc_ode.cpp)
ELSE( cppad_has_adolc )
   SET(adolc_sources "")
ENDIF( cppad_has_adolc )
#
# eigen_sources
IF( cppad_has_eigen )
   SET(eigen_sources eigen_det.cpp eigen_array.cpp)
ELSE( cppad_has_eigen )
   SET(eigen_sources "")
ENDIF( cppad_has_eigen )
#
# BEGIN_SORT_THIS_LINE_PLUS_4
SET(source_list
   ${adolc_sources}
   ${eigen_sources}
   abort_recording.cpp
   acos.cpp
   acosh.cpp
   ad_assign.cpp
   ad_ctor.cpp
   ad_fun.cpp
   ad_in_c.cpp
   ad_input.cpp
   ad_output.cpp
   add.cpp
   add_eq.cpp
   asin.cpp
   asinh.cpp
   atan.cpp
   atan2.cpp
   atanh.cpp
   azmul.cpp
   base2ad.cpp
   base2vec_ad.cpp
   base_alloc.hpp
   base_require.cpp
   bender_quad.cpp
   bool_fun.cpp
   capacity_order.cpp
   change_param.cpp
   check_for_nan.cpp
   compare.cpp
   compare_change.cpp
   complex_poly.cpp
   con_dyn_var.cpp
   cond_exp.cpp
   cos.cpp
   cosh.cpp
   div.cpp
   div_eq.cpp
   equal_op_seq.cpp
   erf.cpp
   erfc.cpp
   exp.cpp
   expm1.cpp
   fabs.cpp
   for_one.cpp
   for_two.cpp
   forward.cpp
   forward_dir.cpp
   forward_order.cpp
   fun_assign.cpp
   fun_check.cpp
   fun_property.cpp
   function_name.cpp
   general.cpp
   hes_lagrangian.cpp
   hes_lu_det.cpp
   hes_minor_det.cpp
   hes_times_dir.cpp
   hessian.cpp
   independent.cpp
   integer.cpp
   interface2c.cpp
   interp_onetape.cpp
   interp_retape.cpp
   jac_lu_det.cpp
   jac_minor_det.cpp
   jacobian.cpp
   log.cpp
   log10.cpp
   log1p.cpp
   lu_ratio.cpp
   lu_vec_ad.cpp
   lu_vec_ad.hpp
   lu_vec_ad_ok.cpp
   mul.cpp
   mul_eq.cpp
   mul_level.cpp
   mul_level_ode.cpp
   near_equal_ext.cpp
   new_dynamic.cpp
   num_limits.cpp
   number_skip.cpp
   numeric_type.cpp
   ode_stiff.cpp
   opt_val_hes.cpp
   pow.cpp
   pow_nan.cpp
   print_for.cpp
   rev_checkpoint.cpp
   rev_one.cpp
   rev_two.cpp
   reverse_one.cpp
   reverse_three.cpp
   reverse_two.cpp
   sign.cpp
   sin.cpp
   sinh.cpp
   sqrt.cpp
   stack_machine.cpp
   sub.cpp
   sub_eq.cpp
   tan.cpp
   tanh.cpp
   tape_index.cpp
   taylor_ode.cpp
   unary_minus.cpp
   unary_plus.cpp
   value.cpp
   var2par.cpp
   vec_ad.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags( example_general "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_general EXCLUDE_FROM_ALL ${source_list})
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_general
   ${adolc_LIBRARIES}
   ${cppad_lib}
   ${colpack_libs}
)
#
# check_example_general
add_check_executable(check_example general)

=== example/ipopt_solve/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example/ipopt_solve directory tests

# Local link directories to search, as determined by pkg-config for ipopt
LINK_DIRECTORIES( ${ipopt_LIBRARY_DIRS} )
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   get_started.cpp
   ipopt_solve.cpp
   ode_inverse.cpp
   retape.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags( example_ipopt_solve "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_ipopt_solve EXCLUDE_FROM_ALL ${source_list})
#
# libraries to be linked into the specified target,
# as determined by pkg-config for ipopt
TARGET_LINK_LIBRARIES(example_ipopt_solve
   ${cppad_lib}
   ${ipopt_LIBRARIES}
   ${colpack_libs}
)

# check_example_ipopt_solve
add_check_executable(check_example ipopt_solve)

=== example/jit/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example/git directory tests
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   atomic.cpp
   compile.cpp
   dynamic.cpp
   get_started.cpp
   jit.cpp
   to_csrc.cpp
)
# END_SORT_THIS_LINE_MINUS_2
#
set_compile_flags( example_jit "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_jit EXCLUDE_FROM_ALL ${source_list})
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_jit
   ${cppad_lib}
   ${colpack_libs}
)
#
# check_example_jit
add_check_executable(check_example jit)

=== include/cppad/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Configure the CppAD include file directory
# -----------------------------------------------------------------------------
# check_match
MACRO(check_match match_variable match_constant output_variable)
   STRING(COMPARE EQUAL ${${match_variable}} ${match_constant} match_flag )
   IF( match_flag )
      SET(${output_variable} 1)
   ELSE( match_flag )
      SET(${output_variable} 0)
   ENDIF( match_flag )
   print_variable(${output_variable})
ENDMACRO(check_match)
# -----------------------------------------------------------------------------
# CMAKE_REQUIRED_name
SET(CMAKE_REQUIRED_DEFINITIONS "")
SET(CMAKE_REQUIRED_FLAGS       "")
SET(CMAKE_REQUIRED_INCLUDES    "")
SET(CMAKE_REQUIRED_LIBRARIES   "")
# -----------------------------------------------------------------------------
# cppad_c_compiler_gnu
IF( "${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" )
   SET(cppad_c_compiler_gnu 1)
ELSE()
   SET(cppad_c_compiler_gnu 0)
ENDIF()
#
# cppad_c_compiler_msvc
IF( "${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC" )
   SET(cppad_c_compiler_msvc 1)
ELSE()
   SET(cppad_c_compiler_msvc 0)
ENDIF()
#
# cppad_c_compiler_clang
IF( "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" )
   SET(cppad_c_compiler_clang 1)
ELSE()
   SET(cppad_c_compiler_clang 0)
ENDIF()
# -----------------------------------------------------------------------------
# compiler_has_conversion_warn
SET( clang_or_gnu 0 )
IF( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" )
   SET(clang_or_gnu 1)
ENDIF( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" )
IF( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" )
   SET(clang_or_gnu 1)
ENDIF( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" )
IF( clang_or_gnu )
   SET(CMAKE_REQUIRED_FLAGS
      "${cppad_cxx_flags} -Wfloat-conversion -Wconversion -Werror"
   )
   #
   SET(source "int main(void) { return 0; }")
   compile_source_test(
      ${cmake_defined_ok} "${source}" compiler_has_conversion_warn
   )
   #
   SET(CMAKE_REQUIRED_FLAGS "")
ELSE( clang_or_gnu )
   SET( compiler_has_conversion_warn 0 )
ENDIF( clang_or_gnu )
# -----------------------------------------------------------------------------
# cppad_boostvector, cppad_cppadvector, cppad_eigenvector, cppad_stdvector
#
check_match(cppad_testvector boost cppad_boostvector)
check_match(cppad_testvector cppad cppad_cppadvector)
check_match(cppad_testvector eigen cppad_eigenvector)
check_match(cppad_testvector std   cppad_stdvector)
IF( NOT cppad_boostvector )
IF( NOT cppad_cppadvector )
IF( NOT cppad_eigenvector )
IF( NOT cppad_stdvector )
MESSAGE(FATAL_ERROR
"cppad_testvector not one of following: boost, cppad, eigen, std."
"This should have been found earlier, please report this as a bug."
)
ENDIF( NOT cppad_stdvector )
ENDIF( NOT cppad_eigenvector )
ENDIF( NOT cppad_cppadvector )
ENDIF( NOT cppad_boostvector )
#
IF( cppad_boostvector )
   # FIND_PACKAGE(Boost) done by ../CMakeLists.txt
   IF( NOT Boost_FOUND )
      MESSAGE(FATAL_ERROR
"cppad_testvector == boost but cannot find boost include files"
      )
   ENDIF( NOT Boost_FOUND )
ENDIF( cppad_boostvector )
#
IF( cppad_eigenvector )
   IF( NOT include_eigen )
      MESSAGE(FATAL_ERROR
"cppad_testvector == eigen but eigen_prefix is not specified"
      )
   ENDIF( NOT include_eigen )
ENDIF( cppad_eigenvector )
# -----------------------------------------------------------------------------
# cppad_has_gettimeofday
#
SET(source "
# include<sys/time.h>
int main(void)
{  struct timeval time;
   gettimeofday(&time, 0);
   return 0;
}"
)
compile_source_test(${cmake_defined_ok} "${source}" cppad_has_gettimeofday)
# -----------------------------------------------------------------------------
# Warn user of the following types are signed:
#  cppad_tape_addr_type, cppad_tape_id_type
FOREACH(cmake_var cppad_tape_id_type cppad_tape_addr_type )
   SET(source "
# include <limits>
# include <cstddef>
int main(void)
{  static_assert(
      ! std::numeric_limits<${${cmake_var}}>::is_signed ,
      \"${cmake_var} is a signed type\"
   );
   return 0;
}
"
   )
   compile_source_test(
      ${cmake_defined_ok} "${source}" ${cmake_var}_is_unsigned
   )
   IF( NOT ${${cmake_var}_is_unsigned} )
      MESSAGE(STATUS
"Warning: using a signed type for ${cmake_var} is for CppAD developers only !"
      )
   ENDIF( NOT ${${cmake_var}_is_unsigned} )
ENDFOREACH( cmake_var )
# -----------------------------------------------------------------------------
# cppad_has_mkstemp
#
SET(source "
# include <stdlib.h>
# if _MSC_VER
# include <io.h>
# else
# include <unistd.h>
# endif

int main(void)
{
   char pattern[] = \"/tmp/fileXXXXXX\";
   int fd = mkstemp(pattern);
   return 0;
}
" )
compile_source_test(${cmake_defined_ok} "${source}" cppad_has_mkstemp )
# -----------------------------------------------------------------------------
# cppad_has_tmpname_s
#
SET(source "
# include <stdio.h>
int main(void)
{  char filename[L_tmpnam_s ];
   if( tmpnam_s(filename, L_tmpnam_s ) != 0 )
      return 1;
   return 0;
}
" )
compile_source_test(${cmake_defined_ok} "${source}" cppad_has_tmpnam_s )
# -----------------------------------------------------------------------------
# configure.hpp
CONFIGURE_FILE(
   ${CMAKE_CURRENT_SOURCE_DIR}/configure.hpp.in
   ${CMAKE_CURRENT_SOURCE_DIR}/configure.hpp
)
# -----------------------------------------------------------------------------

=== speed/adolc/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the speed/adolc directory tests
# Inherit build type from ../CMakeList.txt

# assert include_adolc is true
assert(include_adolc )


# Adds flags to the compiler command line for sources in the current directory
# and below. This command can be used to add any flags, but it was originally
# intended to add preprocessor definitions.
ADD_DEFINITIONS("-DCPPAD_ADOLC_SPEED")

# Local include directories to search (not in package_prefix/includdir)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list ../main.cpp alloc_mat.cpp
   det_lu.cpp
   det_minor.cpp
   mat_mul.cpp
   ode.cpp
   poly.cpp
   sparse_hessian.cpp
   sparse_jacobian.cpp
)
set_compile_flags( speed_adolc "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( speed_adolc EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(speed_adolc
   speed_src
   ${cppad_lib}
   adolc
   ${colpack_libs}
)

# check_speed_adolc
add_check_executable(check_speed adolc "correct 54321 colpack")

=== debian/changelog ===
cppad (2023.00.00.0-2) unstable; urgency=medium

  * Stop trying to install old format ohm documentation (closes: #1027954)
  * Don't try to build documents from new format xrst documentation
  * Change soname, rename libcppad-lib 340.3 to 1456.0
  * Update debian/copyright
  * Update relationship to old cppad package per lintian

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 29 Mar 2023 09:46:00 +0100

cppad (2023.00.00.0-1) unstable; urgency=medium

  * New upstream release
  * Update standards version to 4.6.2, no changes needed.
  * Don't bother patching "incase" in "in case" in comments

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 03 Jan 2023 11:45:55 +0000

=== debian/control ===
Source: cppad
Section: devel
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Miles Lubin <miles.lubin@gmail.com>,
           Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libboost-all-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://projects.coin-or.org/CppAD/
Vcs-Git: https://salsa.debian.org/science-team/cppad.git
Vcs-Browser: https://salsa.debian.org/science-team/cppad

Package: libcppad-lib1456.0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: cppad
Description: Automatic Differentiation of C++ algorithms, shared library
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains runtime support, including shared libraries.

Package: libcppad-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libcppad-lib1456.0 (= ${binary:Version})
Suggests: libcppad-doc
Conflicts: cppad
Provides: cppad
Replaces: cppad
Description: Automatic Differentiation of C++ algorithms, dev files
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains development file: C++ headers and development
 libraries.

Package: libcppad-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Conflicts: cppad
Description: Automatic Differentiation of C++ algorithms, documentation
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains documentation.
 .
 (Or did, and would if the documentation source format hadn't changed
 to xrst which Debian cannot yet process, and will again at some point
 in the future. For now, see https://coin-or.github.io/CppAD/doc.)

## cppad 2024.00.00.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 #
 # Set the minimum required version of cmake for this project.
 # see http://www.cmake.org/pipermail/cmake/2013-January/053213.html
-CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.5)
 #
 # Only interpret if() arguments as variables or keywords when unquoted.
 IF( POLICY CMP0054 )
@@ -16,9 +16,12 @@
 ENDIF( POLICY CMP0054 )
 #
 # cppad_version is used by version.sh to get the version number.
-SET(cppad_version "20230000.0")
+SET(cppad_version "20240000.3")
 SET(cppad_url          "https://coin-or.github.io/CppAD" )
 SET(cppad_description  "Differentiation of C++ Algorithms" )
+IF( NOT DEFINED CMAKE_BUILD_TYPE)
+    SET(CMAKE_BUILD_TYPE "NOTFOUND")
+ENDIF( NOT DEFINED CMAKE_BUILD_TYPE)
 #
 # Set name of this project and create the variables
 # cppad_BINARY_DIR and cppad_SOURCE_DIR.
@@ -92,7 +95,7 @@
 ENDIF( cppad_sparse_list )
 #
 IF( cppad_deprecated )
-   MESSAGE(FATAL_ERROR "cppad_deprecated has been removed from cmake comamnd" )
+   MESSAGE(FATAL_ERROR "cppad_deprecated has been removed from cmake command" )
 ENDIF( cppad_deprecated )
 #
 IF( cmake_install_prefix )
@@ -114,13 +117,14 @@
       )
    ENDIF( ${pkg}_prefix )
 ENDFOREACH(pkg adolc eigen ipopt)
+#
+IF( cmake_needs_dot_slash )
+   MESSAGE(FATAL_ERROR
+      "cmake_needs_dot_slash was removed; see release notes for 2023-06-01"
+   )
+ENDIF( cmake_needs_dot_slash )
 # -----------------------------------------------------------------------------
 # Current Arguments
-#
-# cmake_needs_dot_slash
-command_line_arg(cmake_needs_dot_slash "false" BOOL
-"does cmake need a ./ in the front of an executable name in a custom command"
-)
 #
 # cmake_install_datadir
 command_line_arg(cmake_install_datadir share STRING
@@ -192,6 +196,16 @@
 # cppad_tape_addr_type
 command_line_arg(cppad_tape_addr_type "unsigned int" STRING
 "type used to identify variables on one tape, size must be <= sizeof(size_t)"
+)
+#
+# cppad_static_lib
+command_line_arg(cppad_static_lib FALSE BOOL
+   "If true (false) the cppad library will be static (shared)"
+)
+#
+# cppad_debug_and_release
+command_line_arg(cppad_debug_and_release TRUE BOOL
+   "If true the cppad library and tests will be able to mix debug and release"
 )
 # ----------------------------------------------------------------------------
 #
@@ -223,6 +237,13 @@
 compile_source_test(${cmake_defined_ok} "${source}" use_cplusplus_2017_ok )
 # ----------------------------------------------------------------------------
 #
+# cppad_debug_and_release_01
+IF (cppad_debug_and_release )
+   SET(cppad_debug_and_release_01 1 )
+ELSE (cppad_debug_and_release )
+   SET(cppad_debug_and_release_01 0 )
+ENDIF ( )
+#
 # cppad_debug_which
 # CMAKE_BUILD_TYPE
 SET(debug_even_or_odd FALSE)
@@ -238,17 +259,22 @@
       MESSAGE(FATAL_ERROR
          "Both CMAKE_BUILD_TYPE and cppad_debug_which specified"
       )
-   ENDIF( NOT ${cppad_debug_which} STREQUAL "" )
-   IF(CMAKE_BUILD_TYPE MATCHES Debug)
+   ENDIF( )
+   STRING( TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower )
+   IF(cmake_build_type_lower MATCHES debug)
       SET(cppad_debug_which "debug_all")
-   ELSEIF(CMAKE_BUILD_TYPE MATCHES Release)
+   ELSEIF(cmake_build_type_lower MATCHES release)
       SET(cppad_debug_which "debug_none")
-   ELSEIF(CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
+   ELSEIF(cmake_build_type_lower MATCHES relwithdebInfo)
       SET(cppad_debug_which "debug_none")
-   ELSEIF(CMAKE_BUILD_TYPE MATCHES MinSizeRel)
+   ELSEIF(cmake_build_type_lower MATCHES minsizerel)
       SET(cppad_debug_which "debug_none")
-   ENDIF()
-ELSE( CMAKE_BUILD_TYPE )
+   ELSE( )
+      MESSAGE(FATAL_ERROR
+         "Unknonw CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}"
+      )
+   ENDIF( )
+ELSE( ) # CMAKE_BUILD_TYPE
    IF( "${cppad_debug_which}" STREQUAL debug_all)
       SET(CMAKE_BUILD_TYPE Debug)
    ELSEIF( "${cppad_debug_which}" STREQUAL debug_none)
@@ -260,14 +286,19 @@
       SET(CMAKE_BUILD_TYPE Release)
       SET(debug_even_or_odd TRUE)
    ENDIF( "${cppad_debug_which}" STREQUAL debug_all)
-ENDIF( CMAKE_BUILD_TYPE )
-IF( ${CMAKE_SYSTEM_NAME} STREQUAL "Windows" )
-   IF( debug_even_or_odd )
+ENDIF( ) # CMAKE_BUILD_TYPE
+IF( debug_even_or_odd )
+   IF ( NOT cppad_debug_and_release )
+      MESSAGE(FATAL_ERROR
+"cppad_debug_and_release is false and cppad_debug_wich = ${cppad_debug_which}"
+      )
+   ENDIF ( NOT cppad_debug_and_release )
+   IF( ${CMAKE_SYSTEM_NAME} STREQUAL "Windows" )
       MESSAGE(FATAL_ERROR
       "Cannot have cppad_debug_which equal ${cppad_debug_which} on Windows."
       )
-   ENDIF( debug_even_or_odd )
-ENDIF( ${CMAKE_SYSTEM_NAME} STREQUAL "Windows" )
+   ENDIF( ${CMAKE_SYSTEM_NAME} STREQUAL "Windows" )
+ENDIF( debug_even_or_odd )
 print_variable(CMAKE_SYSTEM_NAME)
 print_variable(cppad_debug_which)
 print_variable(CMAKE_BUILD_TYPE)
@@ -332,23 +363,3 @@
 IF( cppad_has_colpack )
    SET( colpack_libs "ColPack" )
 ELSE( cppad_has_colpack )
-   SET( colpack_libs "" )
-ENDIF( cppad_has_colpack )
-# =============================================================================
-# automated system configuration
-# =============================================================================
-# CMAKE_CXX_FLAGS
-IF( "${cppad_debug_which}" STREQUAL "debug_all" )
-   print_variable(CMAKE_CXX_FLAGS_DEBUG)
-ELSEIF( "${cppad_debug_which}" STREQUAL "debug_none" )
-   print_variable(CMAKE_CXX_FLAGS_RELEASE)
-ELSE( "${cppad_debug_which}" )
-   print_variable(CMAKE_CXX_FLAGS_DEBUG)
-   print_variable(CMAKE_CXX_FLAGS_RELEASE)
-ENDIF( "${cppad_debug_which}" STREQUAL "debug_all" )
-# -----------------------------------------------------------------------------
-# cppad_abs_includedir, cppad_abs_libdir, cppad_abs_datadir, cppad_abs_docdir
-#
-# for dir_types = includedirs, libdirs, datadir, docdir
-FOREACH(dir_types includedirs libdirs datadir docdir)
-   # set dir_type = dir_types with  "dirs" -> "dir"

=== debian/changelog ===
cppad (2024.00.00.3-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 17 Feb 2024 16:20:35 +0000

cppad (2024.00.00.2-2) unstable; urgency=medium

  * Set CMAKE_BUILD_TYPE=RelWithDebInfo since no value causes an FTBFS

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 22 Jan 2024 19:31:17 +0000

cppad (2024.00.00.2-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 22 Jan 2024 16:17:51 +0000

cppad (2024.00.00.1-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 12 Jan 2024 13:18:41 +0000

cppad (2023.00.00.0-3) unstable; urgency=medium

  [ Benoît Vinot ]
  * Solve conflicts between packages.

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 15 Jun 2023 22:29:23 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,6 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: cppad
 Description: Automatic Differentiation of C++ algorithms, shared library
  CppAD is a package for automatic differentiation (AD) of algorithms
  written in C++.  Given appropriately written C++ code that computes a
@@ -32,9 +31,6 @@
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, libcppad-lib1456.0 (= ${binary:Version})
 Suggests: libcppad-doc
-Conflicts: cppad
-Provides: cppad
-Replaces: cppad
 Description: Automatic Differentiation of C++ algorithms, dev files
  CppAD is a package for automatic differentiation (AD) of algorithms
  written in C++.  Given appropriately written C++ code that computes a
@@ -50,7 +46,6 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
-Conflicts: cppad
 Description: Automatic Differentiation of C++ algorithms, documentation
  CppAD is a package for automatic differentiation (AD) of algorithms
  written in C++.  Given appropriately written C++ code that computes a
